/*
 * Copyright 2004-2007 Robbie.JP
 */
package robbie.dao.x;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jdom.Element;

import robbie.dao.Query;
import robbie.util.XmlResource;


/**
 * XMLt@CAXQueryCX^X쐬ĊǗNX.<p>
 * @author Tadahiro Murakami
 */
public class StandaloneXQueryFactory extends XQueryFactory {

    private static final long serialVersionUID = -6926308336952127532L;
    
    private static final Log LOG = LogFactory.getLog(StandaloneXQueryFactory.class);
    
    /** XMLt@CǗNX */
    protected XmlResource xmlResource = null;
    
    /**
     * DIReiŎgpX^hAXQueryCX^X쐬NX.<p>
     * NXpX܂̓t@C琧t@CǍݏȂ܂B
     * filenaméAt@Cłt@CPATHłw肷邱Ƃ\łB
     * At@Cw肷ꍇɂ́Ãt@CclasspathɔzuĂ
     * Kv܂B<br> 
     * <br>
     * ܂AJARt@CŌꍇɂ́A[h͍s܂B
     * ʏ̃fBNgŌꍇɂ̓t@CX^vmF
     * [hs܂B
     * @param filename t@C
     * @param isValidate XML̃[hɌ؂s
     */
    public StandaloneXQueryFactory(String filename, boolean isValidate) {
        this.xmlResource = new XmlResource(filename, isValidate);
        configure();
    }
    
    /**
     * NXpX܂̓t@C琧t@CǍݏȂ܂B<p>
     * @param filename t@C
     */
    public StandaloneXQueryFactory(String filename) {
        this.xmlResource = new XmlResource(filename, false);
        configure();
    }
    
    public void configure() {
        Element root = this.xmlResource.getRootElement();
        configure(root);
    }
    
    public void configureIfNeeded() {
        if (xmlResource.isUpdated()) {
            configure();
        }
    }
    
    public Query createQueryInstance(String id, Object params) {
        configureIfNeeded();
        return super.createQueryInstance(id, params);
    }
    
}
